import "core-js/modules/es6.object.set-prototype-of";

var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

import * as React from "react";
import "./reward.css";
import Radar from "./Radar";
import UserList from "../../../../../components/common/UserList";
import { taker, getApiUrl, loadRewardPop } from "../../../../../helper";
import featureUtils from "@beisen-cmps/feature-utils";

function GoReward(_a) {
  var handleGoReward = _a.handleGoReward;
  var dataUdc = encodeURIComponent(JSON.stringify({
    ext: {
      type: "reward",
      desc: "entry",
      from: "c-reward-radar"
    }
  }));
  return React.createElement("span", {
    className: "go-reward",
    "data-udc": dataUdc,
    onClick: function onClick() {
      handleGoReward();
    }
  }, "\u6211\u4E5F\u8981\u53D1\u7EA2\u5305");
}

function NoReward(_a) {
  var handleGoReward = _a.handleGoReward;
  return React.createElement("div", {
    className: "no-reward"
  }, React.createElement("span", {
    className: "text-describe"
  }, "\u8C01\u7ED9\u4F60\u7684\u5E2E\u52A9\u6700\u5927\uFF1F"), React.createElement(GoReward, {
    handleGoReward: handleGoReward
  }));
}

function NoGuess(_a) {
  var handleGoReward = _a.handleGoReward;
  return React.createElement("div", {
    className: "no-guess"
  }, React.createElement(GoReward, {
    handleGoReward: handleGoReward
  }));
}

function Guess(_a) {
  var users = _a.users,
      handleGoReward = _a.handleGoReward;
  return React.createElement("div", {
    className: "guessed"
  }, React.createElement(GoReward, {
    handleGoReward: handleGoReward
  }), React.createElement("div", {
    className: "guessed-users"
  }, React.createElement("span", {
    className: "describe"
  }, "\u731C\u4F60\u60F3\u6253\u8D4F\uFF1A"), React.createElement(UserList, {
    users: users.slice(0, 8),
    size: 30,
    userClick: handleGoReward
  })));
}

var Reward =
/** @class */
function (_super) {
  __extends(Reward, _super);

  function Reward() {
    var _this = _super !== null && _super.apply(this, arguments) || this;

    _this.state = {
      guessUsers: [],
      users: []
    };

    _this.goReward = function (user) {
      //调用打赏弹层
      if (!window.Features) return;
      var Features = window.Features || {}; // const { Name, Id, Email } = getUserInfo();
      // const myReward = new Features({
      //     needMask: false,
      //     zIndex: 99999999, //层级
      //     changeLeftMenuShade: true,
      //     onClose: function () {
      //         //关闭的回调
      //     },
      //     onSuccess: function () {
      //         //打赏成功的回掉函数
      //     },
      //     domNode: document.getElementById("reward-wrap"), //组件的挂载点
      //     loginUser: {
      //         //当前登陆账号的信息
      //         email: Email,
      //         name: Name,
      //         avatar: {
      //             hasAvatar: UserAvatar.HasAvatar,
      //             img: UserAvatar.Small,
      //             color: UserAvatar.Color
      //         },
      //         id: Id
      //     }
      // });

      var toUser = user ? {
        //被打赏人信息
        email: user.Email,
        name: user.Name,
        avatar: {
          hasAvatar: !!user.PersonalPictureUrl && !!user.PersonalPictureUrl.n,
          img: user.PersonalPictureUrl ? user.PersonalPictureUrl.n : "",
          color: user.AvatarColor
        },
        id: user.UserId
      } : undefined;
      featureUtils.call({
        type: "renderPayReward",
        params: {
          needMask: true,
          objId: "",
          objType: 1,
          toUserInfo: toUser
        }
      }); // myReward.renderPayReward({
      //     needMask: true, //不传的话 就是有
      //     objId: "",
      //     objType: 1,
      //     toUserInfo: toUser,
      // });
    };

    _this.getComponent = function (guessUsers, rewarded) {
      if (!rewarded) {
        return React.createElement(NoReward, {
          handleGoReward: _this.goReward
        });
      } else if (!guessUsers || !guessUsers.length) {
        return React.createElement(NoGuess, {
          handleGoReward: _this.goReward
        });
      } else {
        return React.createElement(Guess, {
          users: guessUsers,
          handleGoReward: _this.goReward
        });
      }
    };

    return _this;
  }

  Reward.prototype.componentDidMount = function () {
    var _this = this;

    var url = getApiUrl("proxy/GetUPaaSCoreGateway/Reward/RewardUserRecommand"); //guess

    var url2 = getApiUrl("proxy/GetUPaaSCoreGateway/Reward/GetLatestRewardUsers"); //radar

    taker(url).then(function (res) {
      if (res.OperationResult && res.OperationObject && res.OperationObject.length) {
        _this.setState({
          guessUsers: res.OperationObject
        });
      }

      taker(url2).then(function (res) {
        if (res.OperationResult && res.OperationObject && res.OperationObject.length) {
          _this.setState({
            users: res.OperationObject
          });
        }
      });
    });
    loadRewardPop();
  };

  Reward.prototype.render = function () {
    var _a = this.props,
        pWidth = _a.pWidth,
        pHeight = _a.pHeight;
    var size = pWidth > pHeight ? pHeight : pWidth;
    var _b = this.state,
        guessUsers = _b.guessUsers,
        users = _b.users;
    if (!size || !users.length) return null;
    var rewarded = users.length ? !!users[0].ObjectId : false;
    return React.createElement("div", {
      className: "reward"
    }, React.createElement("div", {
      className: "reward-inner"
    }, React.createElement("div", {
      className: "radar-area",
      style: {
        minHeight: size - 40 + "px",
        height: rewarded ? "calc(100% - 95px)" : "calc(100% - 135px)"
      }
    }, React.createElement(Radar, {
      users: users.slice(0, 10),
      pWidth: pWidth,
      pHeight: pHeight,
      handleGoReward: this.goReward,
      rewarded: rewarded,
      size: size
    })), React.createElement("div", {
      className: "guess-area"
    }, this.getComponent(guessUsers, rewarded))));
  };

  return Reward;
}(React.Component);

export default Reward;