import "core-js/modules/es6.object.set-prototype-of";

var __extends = this && this.__extends || function () {
  var _extendStatics = function extendStatics(d, b) {
    _extendStatics = Object.setPrototypeOf || {
      __proto__: []
    } instanceof Array && function (d, b) {
      d.__proto__ = b;
    } || function (d, b) {
      for (var p in b) {
        if (b.hasOwnProperty(p)) d[p] = b[p];
      }
    };

    return _extendStatics(d, b);
  };

  return function (d, b) {
    _extendStatics(d, b);

    function __() {
      this.constructor = d;
    }

    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  };
}();

import * as React from 'react';
import './rewarded.css';
import { rewardedFilter } from '../defaultData';
import Filter from '../../../../../components/common/componentTagFilter';
import RewardedList from './RewardedList';
import { taker, getApiUrl } from '../../../../../helper';
import Nodata from '../../../../../components/common/noDataView';

function GoReward(_a) {
  var handleGoReward = _a.handleGoReward;
  var dataUdc = encodeURIComponent(JSON.stringify({
    ext: {
      type: 'reward',
      data: 'rewardwrap'
    }
  }));
  return React.createElement("span", {
    className: 'go-reward',
    "data-udc": dataUdc,
    onClick: function onClick() {
      handleGoReward();
    }
  }, "\u5C1D\u8BD5\u6253\u8D4F");
}

var RewardWrap =
/** @class */
function (_super) {
  __extends(RewardWrap, _super);

  function RewardWrap() {
    var _this = _super !== null && _super.apply(this, arguments) || this;

    _this.state = {
      selectedFilter: 0
    };

    _this.getData = function (k) {
      var url = getApiUrl("proxy/GetUPaaSCoreGateway/Reward/GetLatestReward?scope=" + k);
      taker(url).then(function (res) {
        if (res.OperationResult) {
          _this.setState({
            rewardedDatas: res.OperationObject
          });
        }
      });
    };

    _this.handleFilter = function (k) {
      _this.getData(k);

      _this.setState({
        selectedFilter: k
      });
    };

    return _this;
  }

  RewardWrap.prototype.componentDidMount = function () {
    this.getData(0);
  };

  RewardWrap.prototype.render = function () {
    var _a = this.state,
        selectedFilter = _a.selectedFilter,
        rewardedDatas = _a.rewardedDatas;
    var goReward = this.props.goReward;
    if (selectedFilter == 0 && (!rewardedDatas || !rewardedDatas.length)) return React.createElement("div", {
      className: 'rewarded'
    }, React.createElement(Nodata, {
      icon: 1,
      text: "\u6682\u65E0\u5458\u5DE5\u83B7\u5F97\u6253\u8D4F"
    }), React.createElement(GoReward, {
      handleGoReward: goReward
    }));
    return React.createElement("div", {
      className: 'rewarded'
    }, React.createElement(Filter, {
      tagData: rewardedFilter,
      handleClick: this.handleFilter,
      selectexIndex: selectedFilter
    }), rewardedDatas && rewardedDatas.length ? React.createElement(RewardedList, {
      rewardedData: rewardedDatas,
      goReward: goReward
    }) : React.createElement("div", {
      className: 'rewarded'
    }, React.createElement(Nodata, {
      icon: 1,
      text: "\u6682\u65E0\u5458\u5DE5\u83B7\u5F97\u6253\u8D4F"
    }), React.createElement(GoReward, {
      handleGoReward: goReward
    })));
  };

  return RewardWrap;
}(React.Component);

export default RewardWrap;